<?php

# Importer ces fichiers dans avant l'appel de le class dans votre ficher appelleur.
require_once(DOL_DOCUMENT_ROOT ."/commonobject.class.php");
require_once(DOL_DOCUMENT_ROOT.'/depotvente/html.DepotVente.class.php');
require_once(DOL_DOCUMENT_ROOT.'/categories/categorie.class.php');

class DepotVente 
{

	var $Facture_Avoir_Id;						// id de la facture avoir
	var $Facture_Number;						// nom de la facture
	var $Facture_Type;							// Type de la facture
	var $Facture_Paye;							// Facture payer ou non
	var $Facture_Amount;						// Reglement deja effectuer sur cette facture
	var $Facture_Total_Ht;						// Total HT de la facture
	var $Facture_Total_Ttc;						// Total TTC de la facture
	var $Cat_Name_DepotVente = 'depotvente';	// nom de la categorie depot vente du produit
	var $Cat_Id_DepotVente;						// id de la categorie depot vente
	var $Categories_Id_Product = Array();		// Id des categories du produits
	var $Cat_Id_Array_Product;					// Les categories id du produit				
	var $tva_marge;								// tva sur la marge du produit
	var $PriceDepotVente_Ttc;					// Prix ttc du produit depotvente
	
	function DepotVente(){
		
	}
	
	
	
	/*
	 * Recupere les factures fournisseurs commune au client
	 * a prendre en avoir ( classer non payer )
	 */
	
	function List_Facture_Avoir_Depot_Client($socid, $db){
		
		/*
		 * On verifie variable d entrer obligatoire pour la fonction
		 */
		
		if ( !isset($socid) or empty($socid) ){
			dol_syslog('DepotVente::List_Facture_Avoir_Depot_Client var socid not isset or empty', LOG_ERR);
			return false;
		}
		
		if ( !isset($db) or empty($db) ){
			dol_syslog('DepotVente::List_Facture_Avoir_Depot_Client var db not isset or empty', LOG_ERR);
			return false;
		}
		
		
		/*
		 * On selectionne les factures fournisseurs avoir pour ce client
		 */ 
		
		$sql = '';
		$sql.= 'SELECT *';
		$sql.= ' FROM `llx_facture_fourn` as `ff`';
		$sql.= ' WHERE';
		$sql.= ' `ff`.`fk_soc` = \''.$socid.'\'';
		$sql.= ' AND';
		$sql.= ' `ff`.`paye` = \'0\'';
		$sql.= ';';
		
		dol_syslog('DepotVente::List_Facture_Avoir_Deopt_Client sql='.$sql, LOG_INFO);
		
		$Result = $db->query($sql);
		
		if ( $Result ){
			
			$obj = $db->fetch_object($Result);
			$num = $db->num_rows($Result);
			
			// On recupere que si des factures sont bien presentes pour ce client
			if ( $num > 0 ){
				
				$i=0;				
				while ( $i < $num ){

					$this->Facture_Avoir_Id[$i]	= trim($obj->rowid);
					$this->Facture_Number[$i]	= trim($obj->facnumber);
					$this->Facture_Type[$i]		= trim($obj->type);
					$this->Facture_SocId[$i]	= trim($obj->fk_soc);
					$this->Facture_Paye[$i]		= trim($obj->paye);
					$this->Facture_Total_Ht[$i]	= trim($obj->total_ht);
					
					dol_syslog('DepotVente::List_Facture_Avoir_Depot_Client find Facture_Avoir_Id = '.$this->Facture_Avoir_Id[$i], LOG_INFO);
					
					$i++;
				}
				
			}else{
				dol_syslog('DepotVente::List_Facture_Avoir_Depot_Client Not facture avoir for socid='.$socid.' sql='.$sql, LOG_INFO);				
			}
						
		}else{
			
			dol_syslog('DepotVente::List_Facture_Avoir_Depot_Client error query='.$sql, LOG_ERR);
			return false;
			
		}
		
		dol_syslog('DepotVente::List_Facture_Avoir_Depot_Client sucess for socid='.$socid, LOG_INFO);
		return true;
	}
	
	
	
	/****************************************************
	 * 
	 * Recupere le montant credit d une facture fournisseur
	 * 
	 ****************************************************/
	
	function Montant_F_Fourn($fdepot,$db){
		
		/*
		 * On test les variables d entrere
		 */
			
		if ( !isset($fdepot) or empty($fdepot) ){
			dol_syslog('DepotVente::Montant_F_Fourn Error on var entry fdepot', LOG_ERR);
			return false;
		}
		
		if ( !isset($db) or empty($db) ){
			dol_syslog('DepotVente::Montant_F_Fourn Error on var entry db', LOG_ERR);
			return false;
		}
		
		$sql = '';
		$sql.= 'SELECT';
		$sql.= ' `ff`.`total_ht`,`ff`.`total_ttc`';
		$sql.= ' FROM `llx_facture_fourn` as `ff`';
		$sql.= ' WHERE';
		$sql.= ' `ff`.`rowid` = \''.$fdepot.'\'';
		$sql.= ';';
		
		dol_syslog('DepotVente::Montant_F_Fourn sql='.$sql, LOG_INFO);
		
		$Result = $db->query($sql);
			
		if ( $Result ){
			
			$obj = $db->fetch_object($Result);
			$num = $db->num_rows($Result);
			
			// On recupere que si des factures sont bien presentes pour ce client
			if ( $num == 1 ){

				$this->Facture_Avoir_Id		= $fdepot;
				$this->Facture_Total_Ht		= trim($obj->total_ht);
				$this->Facture_Total_Ttc	= trim($obj->total_ttc);
					
				dol_syslog('DepotVente::Montant_F_Fourn find Facture_Avoir_Id = '.$this->Facture_Avoir_Id.' ht='.$this->Facture_Total_Ht.' ttc='.$this->Facture_Total_Ttc, LOG_INFO);

			}else{
				dol_syslog('DepotVente::Montant_F_Fourn more on facture find id='.$fdepot.' sql='.$sql, LOG_ERR);
				return false;
			}
						
		}else{
			
			dol_syslog('DepotVente::Montant_F_Fourn error query='.$sql, LOG_ERR);
			return false;
			
		}
		
		return true;
	}
	
	
	/*******************************
	 * 
	 * Debite la facture fournisseur
	 * du client 
	 * 
	 *******************************/
	
	function Facture_Avoir_Debit($fdepot, $obj, $db){
		
		/*
		 *  On test les variables d entreer
		 */
		
		if ( !isset($obj) or empty($obj) ){
			dol_syslog('DepotVente::Facture_Avoir_Debit Error on var entry obj', LOG_ERR);
			return false;
		}
		
		if ( !isset($fdepot) or empty($fdepot) ){
			dol_syslog('DepotVente::Facture_Avoir_Debit Error on var entry fdepot', LOG_ERR);
			return false;
		}
		
		if ( !isset($db) or empty($db) ){
			dol_syslog('DepotVente::Facture_Avoir_Debit Error on var entry fdepot', LOG_ERR);
			return false;
		}
		
		/*
		 * On recupere le montant actuel de la facture fournisseur a debiter
		 */
		$M_F_Fourn = New DepotVente();
		if ( ! $M_F_Fourn->Montant_F_Fourn($fdepot,$db) ){
			dol_syslog('DepotVente::Facture_Avoir_Debit error on method DepotVente::Montant_F_Fourn fdepot=id f fourn='.$fdepot, LOG_ERR);
			return false;
		}

		// On verifie que le montant TTC ET HT sont identique
		$this->Facture_Total_Ht		= $M_F_Fourn->Facture_Total_Ht;
		$this->Facture_Total_Ttc	= $M_F_Fourn->Facture_Total_Ttc;
		
		if ( $this->Facture_Total_Ht != $this->Facture_Total_Ttc ){
			dol_syslog('DepotVente::Facture_Avoir_Debit different ttc ht  ttc='.$this->Facture_Total_Ttc.' ht='.$this->Facture_Total_Ht, LOG_ERR);
			return false;
		}else{
			dol_syslog('DepotVente::Facture_Avoir_Debit credit facture fourn='.$this->Facture_Total_Ht, LOG_INFO);
			
		}
		
		/*
		 *  On debite la facture fournisseur
		 */
		
		// On fait le cacul du nouveau montant
		$N_Montant = $this->Facture_Total_Ht - $obj->total;
		dol_syslog('DepotVente::Facture_Avoir_Debit upgrade montant='.$N_Montant, LOG_INFO);
		
		
		// On met a jour la facture fournisseur
		$sql = '';
		$sql.= 'UPDATE';
		$sql.= ' `llx_facture_fourn` as `ff`';
		$sql.= ' SET';
		$sql.= ' `ff`.`total_ht` = \''.$N_Montant.'\'';
		$sql.= ',`ff`.`total_ttc` = \''.$N_Montant.'\'';
		$sql.= ' WHERE';
		$sql.= ' `ff`.`rowid` = \''.$fdepot.'\'';
		$sql.= ';';
		
		dol_syslog('DepotVente::Facture_Avoir_Debit sql='.$sql, LOG_INFO);
		
		$Result = $db->query($sql);
		
		if ( !$Result ){
			dol_syslog('DepotVente::Facture_Avoir_Debit error query sql='.$sql, LOG_INFO);
			return false;
		}
		
		return true;
	}
	
	
	
	/***************************************
	 * 
	 * Recupere le prix achat du produit
	 * si plusieur, le dernier prix sera
	 * prit en compte
	 * 
	 ****************************************/
	
	function prix_achat_product($id_product, $db){
		
		/*
		 * On test les variables d entrees
		 */
		
		if ( !isset($id_product) or empty($id_product) ){
			dol_syslog('DepotVente::prix_achat_product Error on var entry for idfacture', LOG_ERR);
			return false;
		}
		
		if ( !isset($db) or empty($db) ){
			dol_syslog('DepotVente::prix_achat_product Error on var entry for db', LOG_ERR);
			return false;
		}
		
		/*
		 * On selectionne les factures fournisseurs avoir pour ce client
		 */ 
		
		$sql = '';
		
		$sql.= 'SELECT';
		$sql.= ' `pfp`.`price`';
		$sql.= ' FROM';
		$sql.= ' `llx_product_fournisseur` as `pf`';
		
		$sql.= ' LEFT JOIN';
		$sql.= ' `llx_product_fournisseur_price` as `pfp`';
		$sql.= ' ON';
		$sql.= ' `pfp`.`fk_product_fournisseur`=`pf`.`rowid`';
		
		$sql.= ' WHERE';
		$sql.= ' `pf`.`fk_product`='.$id_product;
		
		$sql.= ' ORDER BY `pfp`.`datec` DESC';		
		$sql.= ';';
		
		
		dol_syslog('DepotVente::prix_achat_product sql='.$sql, LOG_INFO);
		
		/*
		 * On va chercher le prix d atchat
		 */
		
		$resql = $db->query($sql);
		
		if ( $resql ){
			
			$num = $db->num_rows($resql);
			$i=0;
			
			// Test produit trouver
			if ( $num <= 0 ){
				dol_syslog('DepotVente::prix_achat_product no buyprice for product_id='.$id_product, LOG_ERR);
				return false; // possible que le possible ne fasse pas partie de la cat depotvente, donc true.
			}
			
			// On ne prend que le dernier prix d achat inserer
			if ( $num >= 1 ){
				
				$obj = $db->fetch_object($resql);
				if ($obj)
				{
					// On ne prend que la premiere ligne du resultat sql
					$this->prix_achat_ht =  $obj->price;
					dol_syslog('DepotVente::prix_achat_product prix_achat_ht='.$this->prix_achat_ht, LOG_INFO);
					
				}
			}
			
		}else{
			dol_syslog('DepotVente::prix_achat_product error on query='.$sql, LOG_ERR);
			return false;
		}
		
		
		/*
		 * On test si prix d achat a bien ete detecter
		 */
		
		if ( !isset($this->prix_achat_ht) or empty($this->prix_achat_ht) ){
			dol_syslog('Depotvente::prix_ahat_product error obj->price is empty', LOG_ERR);
			return false;
		}
		
		return true;
	}
	
	/***********************************
	 *
	 * Retourne l id cat de la 
	 * categorie depot vente
	 * 
	 ***********************************/
	
	function id_cat_depotvente($Cat_Name_Depotvente, $db){

		/*
		 * On test les variables d entrees
		 */
		
		if ( !isset($Cat_Name_Depotvente) or empty($Cat_Name_Depotvente) ){
			dol_syslog('DepotVente::id_cat_depotvente error on var entry Cat_Name_Depotvente', LOG_ERR);
			return false;
		}
		
		if ( !isset($db) or empty($db) ){
			dol_syslog('DepotVente::id_cat_depotvente error on var entry db', LOG_ERR);
			return false;
		}		
	
				
		/*
		 * On recupere l id de la catetgorie depotvente
		 */
		
		 $Categorie = New Categorie($db);
		 if ( !$Cat = $Categorie->rechercher('', $Cat_Name_Depotvente,0,$exact=true) ){
		 	dol_syslog('DepotVente::id_cat_depotvent error on search id cat for cat label='.$Cat_Name_Depotvente, LOG_ERR);
		 	return false;
		 }
		 
		 $this->Cat_Id_DepotVente = $Cat[0]->id;		 
		 dol_syslog('DepotVente::id_cat_depotvente cat_id='.$this->Cat_Id_DepotVente.' cat_name='.$Cat_Name_Depotvente, LOG_INFO);
		 
		 return true;
		
	}
	
	/***********************
	 * 
	 * List les categories en id
	 * du produit
	 * 
	 ***************************/
	
	function List_Cat_Product($IdProduct,$IdCategorie,$db){

		/*
		 * On test les variables d entrees
		 */
		if ( !isset($IdProduct) or empty($IdProduct)){
			dol_syslog('DepotVente::List_Cat_Product error on var entri IdProduct', LOG_ERR);
			return false;
		}
		
		if ( !isset($IdCategorie) or empty($IdCategorie)){
			dol_syslog('DepotVente::List_Cat_Product error on var entri IdCategorie', LOG_ERR);
			return false;
		}
		
		if ( !isset($db) or empty($db)){
			dol_syslog('DepotVente::List_Cat_Product error on var entri db', LOG_ERR);
			return false;
		}
		
		/*
		 * On List les categories du produits
		 */
		
		$sql = '';
		$sql.= 'SELECT `c`.`fk_categorie`';
		$sql.= ' FROM `llx_categorie_product` as `c`';
		$sql.= ' WHERE';
		$sql.= ' `c`.`fk_product`='.$IdProduct;
		$sql.= ' AND';
		$sql.= ' `c`.`fk_categorie`='.$IdCategorie;
		$sql.= ';';
		
		dol_syslog('DepotVente::List_Cat_Product query='.$sql, LOG_INFO);
		
		$resql = $db->query($sql);
		
		if ( $resql ){
			
			$num = $db->num_rows($resql);
			$i=0;
			
			// Test si pas de categorie sur le produit
			if ( $num <= 0 ){
				dol_syslog('DepotVente::List_Cat_Product no registration for cat_id='.$IdCategorie, LOG_DEBUG);
				return false; // possible que le possible ne fasse pas partie de la cat depotvente, donc true.
			}
			
			while ($i < $num)
			{
				$obj = $db->fetch_object($resql);
				if ($obj)
				{
					$this->Categories_Id_Product[$i] =  $obj->fk_categorie;
					dol_syslog('DepotVente::List_Cat_Product cat '.$i.' detect='.$this->Categories_Id_Product[$i], LOG_INFO);
					
				}
				$i++;
			}
			
			
		}else{
			dol_syslog('DepotVente::List_Cat_Product error on query='.$sql, LOG_ERR);
			return false;
		}
		
		return true;
	}
	
	/************************************************
	 * 
	 * Verifie si le produit
	 * fait bien partie de la categorie depotvente
	 * 
	 *************************************************/
	
	function Verif_Cat_DepotVente($CatArray, $Cat_Id_DepotVente){
		
		/*
		 * On test les variables d entreer
		 */	
		
		if ( !isset($CatArray) or empty($CatArray)){
			dol_syslog('DepotVente::Verif_Cat_DepotVente Error on var entry CatArray', LOG_ERR);
			return false;
		}
		
		if ( !isset($Cat_Id_DepotVente) or empty($Cat_Id_DepotVente)){
			dol_syslog('DepotVente::Verif_Cat_DepotVente Error on var entry Cat_Id_DepotVente', LOG_ERR);
			return false;
		}
		
		/*
		 * On test si la categorie depotvente est bien presente dans la liste
		 * des categories du produit
		 */
		
		$i=0;
		while ( isset($CatArray[$i]) && !empty($CatArray[$i])){
			
			if ( $CatArray[$i] == $Cat_Id_DepotVente ){
				dol_syslog('DepotVente::Verif_Cat_DepotVente Verif cat depotvente for product sucess', LOG_INFO);
				$Cat_Ok = 1;
				return true;
			}
			
			$i++;
		}
		
		if ( $Cat_Ok != 1 ){
			dol_syslog('DepotVente::Verif_Cat_DepotVente error on verif cat depotvente for product', LOG_ERR);
			return false;
		}
		
		return true;
	}
	
	
	/**********************************
	 * 
	 * Formule de la tva sur marge 
	 * 
	 **********************************/
	
	function calc_tva_marge($product_price_achat_ht, $product_price_vente_ht, $taux_tva){
		
		/*
		 * On test les variables d entreer
		 */
		
		if ( !isset($product_price_achat_ht) or empty($product_price_achat_ht) ){
			dol_syslog('DepotVente::tva_marge error on var entry product_price_achat_ht');
			return false;
		}
		
		if ( !isset($product_price_vente_ht) or empty($product_price_vente_ht) ){
			dol_syslog('DepotVente::tva_marge error on var entry product_price_vente_ht');
			return false;
		}
		
		if ( !isset($taux_tva) or empty($taux_tva) ){
			dol_syslog('DepotVente::tva_marge error on var entry taux_tva');
			return false;
		}
		
		/*
		 * On fait le calcul de la tva sur la marge
		 */
		
		$coef_tva = $taux_tva / 100;
		
		$marge_ht	= $product_price_vente_ht - $product_price_achat_ht;
		$this->tva_marge	= $marge_ht * $coef_tva;
		
		return true;
	}
	
	
	
	/**********************************
	 * 
	 *  Modifie la note du produit
	 * 
	 * file = fichier php en cour d execution
	 * 
	 **********************************/
	
	function Modify_Note_Product($ObjectProduct, $note, $user){
		
		/*
		 * On test les variables d entrees
		 */
		
		if ( !isset($ObjectProduct) or empty($ObjectProduct)){
			dol_syslog('DepotVente::Modify_Note_Product error on var entry ObjectProduct', LOG_ERR);
			return false;
		}
		
		if ( !isset($note) or empty($note) ){
			dol_syslog('DepotVente::Modify_Note_Product error on var entry note', LOG_ERR);
			return false;
		}
		/*
		if ( !isset($user) or empty($user) ){
			dol_syslog('DepotVente::Modify_Note_Product error on var entry user', LOG_ERR);
			return false;
		}
		//*/
		/*
		 * On detect la page en cour du visiteur
		 */
		
		$path = $_SERVER['PHP_SELF'];
	    $file = basename($path);
	    dol_syslog('DepotVente::Modify_Note_Product the file php exec is='.$file, LOG_INFO);
		
	    /*
	     * On modifie la page du produit
	     */
	    
	    // Modification de la note du produit que a l affichage de la fiche du produit

      	$ObjectProduct->note = $note;
	 		
      	if ( $ObjectProduct->update($ObjectProduct->id, $user) ){
      		dol_syslog('DepotVente::Modify_Note_Product id_product='.$ObjectProduct->id.' add note='.$note, LOG_INFO);
      	}else{
      		dol_syslog('DepotVente::Modify_Note_Product error on mehtod update product for id_product='.$ObjectProduct->id, LOG_ERR);
      		return false;
      	}
      	
		return true;
	}

	
	/***************************
	 * 
	 * Renvoi TVA sur marge
	 * du produit
	 * 
	 ***************************/
	
	function product_tva_marge($ObjectProduct,$user, $db){

		// On test les var d entrees		
		if ( !isset($ObjectProduct) or empty($ObjectProduct) ){
			dol_syslog('DepotVente::product_tva_marge Error on var entry for idfacture', LOG_ERR);
			return false;
		}
		
		if ( !isset($db) or empty($db) ){
			dol_syslog('DepotVente::product_tva_marge Error on var entry for db', LOG_ERR);
			return false;
		}		
		dol_syslog('DepotVente::product_tva_marge id product='.$ObjectProduct->id.' cat depotvente='.$this->Cat_Name_DepotVente, LOG_INFO);

		// On initialise la note de l article
		$note = '-';
		$this->Modify_Note_Product($ObjectProduct,$note,$user);

		// Recupere id categorie depotvente
		if ( !$this->id_cat_depotvente($this->Cat_Name_DepotVente, $db) ){
			dol_syslog('DepotVente::product_tva_marge error on methode DepotVente::id_cat_depotvente for cat_name='.$this->Cat_Name_DepotVente, LOG_ERR);
			$note = 'Impossible de recuperer l id de la categorie depotvente';
			return false;
		}
		
		//$this->Cat_Id_DepotVente = $Categorie->Cat_Id_DepotVente;
		dol_syslog('DepotVente::product_tva_marge find cat_id='.$this->Cat_Id_DepotVente.' for cat_name='.$this->Cat_Name_DepotVente, LOG_INFO);

		// List categories du produit
		if ( !$this->List_Cat_Product($ObjectProduct->id,$this->Cat_Id_DepotVente,$db) ){
			dol_syslog('DepotVente::product_tva_marge no cat for product_id='.$ObjectProduct->id, LOG_DEBUG);
			$note = '-';
			$this->Modify_Note_Product($ObjectProduct,$note,$user);
			return false;
		}
		
		// Verifie produit presente dans categorie depotvente
		//$this->Categories_Id_Product
		if ( !$this->Verif_Cat_DepotVente($this->Categories_Id_Product,$this->Cat_Id_DepotVente) ){
			dol_syslog('DepotVente::product_tva_marge error on methode DepotVente::Verif_Cat_DepotVente', LOG_ERR);
			$note = 'Impossible de verifier si le produit fait partie de la categorie depotvente.';
			$this->Modify_Note_Product($ObjectProduct,$note,$user);
			return false;
		}	
		
		// Prix achat du produit		
		if ( !$this->prix_achat_product($ObjectProduct->id,$db) ){
			dol_syslog('DepotVente::product_tva_marge error on methode DepotVente::prix_achat_product', LOG_ERR);
			$note = 'Prix achat manquant pour ce produit DEPOT VENTE.';
			$this->Modify_Note_Product($ObjectProduct,$note,$user);
			return false;
		}		
		
		// Verifie si produit possede un prix de vente
		if ( !isset($ObjectProduct->price) or empty($ObjectProduct->price)){
			dol_syslog('DepotVente::product_tva_marge not price detected for this product depotvente='.$ObjectProduct->id, LOG_ERR);
			$note = 'Prix de vente manquant pour ce produit DEPOT VENTE.';
			$this->Modify_Note_Product($ObjectProduct,$note,$user);
		}

		// Cacul tva sur la marge
		if ( !$this->calc_tva_marge($this->prix_achat_ht, $ObjectProduct->price, $ObjectProduct->tva_tx) ){
			dol_syslog('DepotVente::product_tva_marge error on method DepotVente::tva_marge for product='.$ObjectProduct->id, LOG_ERR);
			$note = 'Impossible de calculer la tva sur marge ce produit DEPOT VENTE.';
			$this->Modify_Note_Product($ObjectProduct,$note,$user);
			return false;
		}		
		dol_syslog('DepotVente::product_tva_marge tva marge for product='.$ObjectProduct->id.' = '.$this->tva_marge, LOG_INFO);
		dol_syslog('DepotVente::product_tva_marge multiprice='.$ObjectProduct->multiprices_base_type[0], LOG_INFO);
		
		// On met a jour le prix ( mode multiprice )
		//$ObjectProduct = $ObjectProduct->fetch($ObjectProduct->id);
		$this->PriceDepotVente_Ttc = price2num($ObjectProduct->price + $this->tva_marge, 'MU');
		
		//*
		
		$ObjectProduct->price;												// prix a lui meme
		$ObjectProduct->price_ttc 			= $this->PriceDepotVente_Ttc;	// avec tva sur marge
		$ObjectProduct->price_base_type		= 'HT';							// On se base sur le HT
		$ObjectProduct->status				= 1;							// En vente
		$ObjectProduct->tva_tx;												// taux de tva a lui meme
		$user->id = 1;
		
		if ( !$ObjectProduct->_log_price($user, 1) ){		
			
			dol_syslog('DepotVente::product_tva_marge error on update price '.$this->PriceDepotVente_Ttc.' for product_id='.$ObjectProduct->id, LOG_ERR);
			$note = 'Depot Vente : Erreur pendant la mise a jour du prix '.$this->PriceDepotVente_Ttc.' comprenant la tva sur la marge';
			$this->Modify_Note_Product($ObjectProduct,$note,$user);
			return false;
		}else{
			dol_syslog('DepotVente::product_tva_marge '.$user->id.' update price '.$this->PriceDepotVente_Ttc.' for product_id='.$ObjectProduct->id.' success', LOG_INFO);
		}
		//*/
		
		
		// note produit indiquant tva sur marge
		$note = "<span style=\"font-weight:bold;\">P_fourn = </span>".round($this->prix_achat_ht, 2)." HT<span style=\"margin-left:20px;font-weight:bold;\">P_vente = </span>".round($ObjectProduct->price, 2)." HT / ".round($this->PriceDepotVente_Ttc, 2)." TTC<span style=\"margin-left:20px;font-weight:bold;\">Tva_marge = </span>".round($this->tva_marge, 2)." <span style=\"margin-left:15px;\">(Depot Vente)</span>";
		if ( !$this->Modify_Note_Product($ObjectProduct, $note, $user)){
			dol_syslog('DepotVente::product_tva_marge error on methode DepotVente::Modify_Note_Product', LOG_ERR);
			return false;
		}	

		// On modifie le produit de vente ttc avec just la tva sur marge
		$ObjectProduct->update($ObjectProduct->id, $user);		 
		 
		return true;
	}
	
	
	
	
	
	/***************************************
	 * 
	 * Adapte la ligne de facturation
	 * a la tva marge depotvente 
	 * 
	 ****************************************/
	
	function Ligne_Facture_Depot($obj_facturedet,$user,$db){
		
		
		
		//On verifie les variables d entreer	
		if ( !isset($obj_facturedet) or empty($obj_facturedet)){
			dol_syslog('DepotVente::Ligne_Facture_Depot error on var entry id_facturedet', LOG_ERR);
			return false;
		}
		
		if ( !isset($user) or empty($user)){
			dol_syslog('DepotVente::Ligne_Facture_Depot error on var entry user', LOG_ERR);
		}else{
			global $user;
		}	
			
		if ( !isset($db) or empty($db)){
			dol_syslog('DepotVente::Ligne_Facture_Depot error on var entry db', LOG_ERR);
			return false;
		}

		
		// On recupere les informations sur le produit
		$ObjectProduct = New Product($db);
		if ( !$ObjectProduct->fetch($obj_facturedet->fk_product) ){
			dol_syslog('DepotVente::Ligne_Facture_Depot Impossible fetch product='.$obj_facturedet->fk_product, LOG_ERR);
			return false;
		}else{
			dol_syslog('DepotVente::Ligne_Facture_Depot product_id fetch='.$ObjectProduct->id, LOG_INFO);
		}
		
		
		// On recupere la tva sur marge depotvente
		if ( !$this->product_tva_marge($ObjectProduct, $user, $db) ) {
			dol_syslog('DepotVente::Ligne_Facture_Depot error on methode DepotVente::product_tva_marge for product='.$ObjectProduct->id, LOG_ERR);
			return false;
		}else{
			dol_syslog('DepotVente::Ligne_Facture_Depot product='.$ObjectProduct->id.' price='.$ObjectProduct->price.' tva_marge='.$this->tva_marge.' price_depovente_ttc='.$this->PriceDepotVente_Ttc.' id_ligne_facture='.$obj_facturedet->rowid, LOG_INFO);
		}

		// On met a jour les prix avec la tva marge
		$FactureLigne = New FactureLigne($db);
		
		if ( !$FactureLigne->fetch($obj_facturedet->rowid) ){
			dol_syslog('DepotVente::Ligne_Facture_Depot error on methode FactureLigne::fetch rowid='.$obj_facturedet->rowid, LOG_ERR);
			return false;
		}else{
			dol_syslog('DepotVente::Ligne_Facture_Depot FactureLigne::fetch ok', LOG_INFO);
		}
		
		$FactureLigne->subprice		= round( $ObjectProduct->price, 2 );							// Prix unitaire HT
		$FactureLigne->total_ht		= round( $ObjectProduct->price * $FactureLigne->qty, 2 );		// total ttc de la ligne
		$FactureLigne->total_tva	= round( $this->tva_marge * $FactureLigne->qty, 2 );			// montant de la tva de la ligne
		$FactureLigne->total_ttc	= round( $this->PriceDepotVente_Ttc * $FactureLigne->qty, 2);	// total ttc de la ligne
		
		if( !$FactureLigne->update($notriggers=1) ){
			dol_syslog('DepotVente::Ligne_Facture_Depot Error on methode FactureLigne::update', LOG_ERR);
			return false;
		}else{
			dol_syslog('DepotVente::Ligne_Facture_Depot update ok f_ligne='.$FactureLigne->rowid.' qty='.$FactureLigne->qty.' tota_tva='.$FactureLigne->total_tva.' total_ht='.$FactureLigne->total_ht.' total_ttc='.$FactureLigne->total_ttc.' desc='.$FactureLigne->desc, LOG_INFO);
		}

		dol_syslog('DepotVente::Ligne_Facture_Depot [ TERMINER ]', LOG_INFO);
		return true;
	}
	
	
}

?>